<?xml version='1.0' encoding='utf-8'?>
| <!DOCTYPE rfc SYSTEM "rfc2629-xhtml.ent" [
// external reference to RFCs
<!ENTITY rfc2119 SYSTEM "http://xml.resource.org/public/rfc/bibxml/reference.RFC.2119.xml">
// local reference to another doc
| ]>

// processing instructions
<?rfc toc="yes"?>
<?rfc symrefs="yes"?>
<?rfc compact="yes"?>
<?rfc subcompact="no"?>
<?rfc strict="no"?>
<?rfc rfcedstyle="yes"?>
<?rfc comments="yes"?>
<?rfc inline="yes"?>


// categories: std | bcp | info | exp | historic
rfc(category='info' number='2820021' consensus='false' ipr='trust200902' docName='tim-operation-architecture-01' submissionType='be-cem-mro' xml:lang='en' version='3')
  front
    title(abbrev='TIM-operation architecture') TIM-operation architecture
    author(fullname='Sylvain Fargier' initials='S.F.' role='editor' surname='Fargier')
      organization CERN
      address
        postal
          street 1, Esplanade des Particules
          code 1217
          city Meyrin
          country Switzerland
        email sylvain.fargier@cern.ch
    author(fullname='Mathieu Donzé' initials='M.D.')
      organization CERN
      address
        postal
          street 1, Esplanade des Particules
          code 1217
          city Meyrin
          country Switzerland
        email mathieu.donze@cern.ch
    date(year='2022' month="November")

    keyword template

    abstract
      t
        | This document describes the technical infrastructure architecture used
        | to access and control the TIM (Train Inspection Monorail).


  middle

    section
      name Introduction
      t
        | This document describes the technical infrastructure architecture used
        | to access and control the TIM (Train Inspection Monorail).

      // This one is a 'must' :)
      section
        name Requirements Notation

        t
          | The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT",
          | "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this
          | document are to be interpreted as described in BCP 14,
          | #[xref(target='RFC2119' format='default') RFC2119].

      section
        name General Overview

        figure
          name TIM-operation General Overview
          artwork(align='center' type='binary-art' src='tim-operation-architecture/general-overview.png')

    section
      name Infrastructure

      section
        name TIM Components

        t
          | The TIM base operation and control requires three main components:
        ul
          li A control PLC (#[xref(target="CONTROL_PLC")])
          li A LTE router (#[xref(target="ROUTER")])
          li One or several inspection cameras (#[xref(target="CAMERAS")])

        section(anchor="CONTROL_PLC")
          name Control PLC

          t
            | The Control PLC is used to drive the TIM, it #[bcp14 SHOULD] provide
            | the following features:
          ul
            li Direct motion (jog backward and forward)
            li DCUM based motion
            li Cameras power management
            li FIXME

          t
            | It #[bcp14 MUST] be visible from the #[xref(target="ROUTER") router]
            | local-network.

        section(anchor="ROUTER")
          name LTE Router

          t
            | Each TIM LTE router #[bcp14 SHOULD] use a different local-network subnet to
            | allow users to join several trains' VPN on a single machine.

          t
            | it is #[bcp14 RECOMMENDED] to declare a local-network
            | that can be used to easily identify the TIM, ex: #[tt 192.168.#[strong 12].0/24] for TIM12.

          t
            | The #[xref(target="CONTROL_PLC") Control PLC] and
            | #[xref(target="CAMERAS") Cameras] #[bcp14 MUST] be connected on the router's local-network.

          t
            | The router #[bcp14 MUST] be reachable from the #[xref(target='CERN_TN') CERN Technical Network],
            | by possibly using #[eref(target="https://landb.cern.ch/landb/portal/sets/showSetInfo?setId=3946") APN EXPOSED TO TN] trusted-set.

          t
            | The router #[bcp14 MUST] provide an #[xref(target="OPENVPN") OpenVPN] Virtual Private Network (VPN), that
            | #[bcp14 MUST] be reachable from #[xref(target='CERN_TN') CERN Technical Network] and #[bcp14 MUST] route network packets
            | to its local-network. It #[bcp14 SHOULD NOT] route packets from VPN to the Internet.

          t
            | The VPN #[bcp14 SHOULD] be configured to use certificate based authentication,
            | credentials #[bcp14 SHOULD] be stored in a #[xref(target="MRO_PASSWORD_STORE") password-store], see #[xref(target="CREDENTIALS")].

          t
            | Additional credential certifcates #[bcp14 MAY] be generated, but
            | the ones dedicated to operation #[bcp14 MUST] only be used on the
            | #[xref(target="FEC") FEC].

        section(anchor="CAMERAS")
          name Cameras

          t
            | Cameras #[bcp14 MUST] be visible from the #[xref(target="ROUTER") router]
            | local-network.

      section
        name Operational Components

        t
          | To support the TIM-operation the following components are #[bcp14 REQUIRED]:
        ul
          li A Front-End Computer (FEC) per TIM (#[xref(target="FEC")])
          li A #[xref(target="CERN_PAAS") PaaS (OpenShift)] TIM dedicated project (#[xref(target="APPS")])

        t
          | The FECs #[bcp14 MUST] be connected to the #[xref(target='CERN_TN') CERN Technical Network].


        section(anchor="FEC")
          name Front-End Computer

          t
            | Each Front-End Computer (FEC) #[bcp14 MUST] be connected to its associated TIM using
            | the #[xref(target="ROUTER") LTE router] VPN.

          t
            | The TIM-operation control is achieved through the following interfaces:
          table
            thead
              tr #[th interface] #[th FESA class] #[th purpose]
            tbody
              tr #[td PLC] #[td FIXME] #[td motion-control ...]
              tr #[td Router] #[td FIXME] #[td router monitoring, signal strength ...]

          t
            | The Front-End Computer (FEC) #[bcp14 MUST] expose the cameras
            | by forwarding traffic on its own ports (visible on TN), starting on port #[tt 10000].

          t
            | Exposed cameras #[bcp14 SHOULD NOT] be directly accessed, a dedicated
            | #[xref(target="CAM_SERVICE") camera streaming service] will be deployed
            | for this purpose (protecting the GSM network from being overloaded).

          t
            | The Front-End Computer VPN and port-forwarding configuration is
            | managed from a #[xref(target="MRO_TIM_FEC_PREPARE") dedicated project].

          t
            | This project #[bcp14 MUST] be used to modify configuration (adding/removing cameras)
            | and renewing credentials.


        section(anchor="APPS")
          name Applications

          t
            | TIM-operation applications #[bcp14 MUST] be deployed on #[xref(target="CERN_PAAS") PaaS (OpenShift)] on a
            | a #[xref(target="MRO_TIM_PAAS") TIM dedicated project].

          t
            | The #[xref(target="MRO_TIM_PAAS") TIM PaaS project] #[bcp14 MUST]
            | be in a trusted-set to access #[xref(target='CERN_TN') CERN Technical Network].
            | It #[bcp14 SHOULD] be visible only from the #[xref(target='CERN_GPN') CERN General Purpose Network] (and not externally visible).

          t Services to support the following applications #[bcp14 MUST] be deployed:
          ul
            li TIM Control for Inspection (#[xref(target="TIM_CONTROL_APP")])
            li Fixed-Displays and monitoring (#[xref(target="FIXED_DISPLAYS_APP")])

          t
            | All applications #[bcp14 MUST] be developped following the
            | #[xref(target="MRO_WEBDEV_GUIDELINES") BE-CEM-MRO WebDev Guidelines]
            | using #[xref(target="MRO_BASEVUE_WIDGETS") Base-Vue Widgets].

          section(anchor="TIM_CONTROL_APP")
            name TIM Control

            t
              | An application dedicated to TIM-operation #[bcp14 MUST] be implemented,
              | it #[bcp14 MUST] provide the following features :
            ul
              li PTZ camera display (single-stream configurable quality)
              li PTZ camera control
              li TIM motion-control (using DCUM and/or direct control)
              li TIM general status

            t
              | This application #[bcp14 MUST] be #[xref(target="CERN_SSO") SSO] protected using a management e-group),
              | the following roles #[bcp14 SHOULD] be supported:
            table(align='center')
              name Operation roles
              thead
                tr #[th role] #[th permissions]
              tbody
                tr #[td user] #[td basic control]
                tr #[td admin] #[td advanced control and maintenance]
                tr #[td expert] #[td full control and debug information]

            t
              | There #[bcp14 SHOULD] be only a single application to access all
              | TIM devices, the application #[bcp14 SHOULD] use url-navigation.

            t
              | Device communication #[bcp14 SHOULD] be achieved using
              | #[xref(target="MRO_CMW_EXPRESS") CMW-express back-end], connecting
              | the #[xref(target="FEC") Front-End Computer].

            t
              | It #[bcp14 MAY] use the #[xref(target="CAM_SERVICE")] to display
              | cameras.

            t
              | The TIM Control application is available #[xref(target="MRO_TIM_CONTROL_APP") here].

          section(anchor="FIXED_DISPLAYS_APP")
            name Fixed-Displays

            t
              | TIM-operation fixed-displays #[bcp14 SHOULD] be implemented using
              | the #[xref(target="CERN_WRAP") CERN Web Rapid Application Platform].

            t
              | It #[bcp14 SHOULD] use #[xref(target="MRO_SSVG") SSVG] to graphically
              | display current TIMs position and status.

            t
              | It #[bcp14 MUST] display cameras using a #[xref(target="CAM_SERVICE") dedicated service].

            section(anchor="CAM_SERVICE")
              name CAM Service

              t
                | Camera streams and interfaces are made available on
                | the #[xref(target="CERN_TN") CERN Technical Network] by the
                | #[xref(target="FEC") Front-End Computer] but those streams
                | transit over the GSM network which is bandwidth limited.

              t
                | To support multiple clients (fixed-displays, operation ...)
                | on the same stream a #[xref(target="MRO_CAM_EXPRESS") cam-express]
                | service #[bcp14 MUST] be used.

              t
                | This service #[bcp14 SHOULD] also prepare streams for fixed-displays,
                | by providing a multiplexed (carousel) video.

              t
                | Some dedicated interface #[bcp14 MAY] be added for the #[xref(target="TIM_CONTROL_APP") Control Application]
                | to disable fixed-displays streaming during resource-demanding operations.

      section(anchor="CREDENTIALS")
        name Credentials

        t
          | Credentials, such as VPN certificates and router login/password
          | #[bcp14 MUST] be stored in a #[xref(target="MRO_PASSWORD_STORE") password-store].

  back

    references
      name References
      references
        name Normative References
        | &rfc2119;

      references
        name Informative References

      references
        name URL References

        reference(anchor="OPENVPN" target="https://openvpn.net")
          front
            title OpenVPN virtual private network (VPN)
            author
              organization OpenVPN Inc.
            date(year="2001")
          annotation #[tt License: GPLv2]


      references
        name CERN References
        reference(anchor='CERN_TN' target='https://cern.service-now.com/service-portal?id=service_element&name=Technical-Network')
          front
            title CERN Technical Network
            author
              organization CERN
            date(year='2022')
        reference(anchor='CERN_GPN' target='https://cern.service-now.com/service-portal?id=service_element&name=Campus-Network')
          front
            title Campus Network Service (GPN)
            author
              organization CERN
            date(year='2022')
        reference(anchor='CERN_SSO' target='https://cern.service-now.com/service-portal?id=service_element&name=SSO-Service')
          front
            title Single Sign On and Account Management Services
            author
              organization CERN
            date(year='2022')
        reference(anchor='CERN_PAAS' target='https://cern.service-now.com/service-portal?id=service_element&name=PaaS-Web-App')
          front
            title PaaS Web Application Hosting Service (OpenShift)
            author
              organization CERN
            date(year='2022')
        reference(anchor='CERN_WRAP' target='https://wikis.cern.ch/display/CD/WRAP+Home')
          front
            title Web Rapid Application Platform (WRAP)
            author
              organization CERN
            date(year='2022')

      references
        name BE-CEM-MRO References

        reference(anchor='MRO_TIM_PAAS' target='FIXME')
          front
            title TIM-operation PaaS project
            author
              organization CERN
            date(year='2022')
        reference(anchor='MRO_TIM_FEC_PREPARE' target='FIXME')
          front
            title TIM-operation FEC installation tools
            author
              organization CERN
            date(year='2022')
        reference(anchor='MRO_TIM_CONTROL_APP' target='FIXME')
          front
            title TIM-operation control application
            author
              organization CERN
            date(year='2022')
        reference(anchor='MRO_PASSWORD_STORE' target='https://gitlab.cern.ch/mro/common/tools/password-store')
          front
            title BE-CEM-MRO password-store
            author
              organization CERN
            date(year='2022')

        reference(anchor="MRO_WEBDEV_GUIDELINES" target="https://mro-dev.web.cern.ch/docs/std/en-smm-apc-web-guidelines.html")
          // FIXME
          front
            title BE-CEM-MRO Web Development Guidelines
            author
              organization CERN
            date(year='2019')

        reference(anchor="MRO_BASEVUE_WIDGETS" target="https://gitlab.cern.ch/mro/common/www/base-vue")
          // FIXME
          front
            title BE-CEM-MRO base-vue widgets
            author
              organization CERN
            date(year='2019')

        reference(anchor='MRO_CAM_EXPRESS' target='https://gitlab.cern.ch/mro/common/www/cam-express')
          front
            title Cam-express: camera streaming and multiplexing service
            author
              organization CERN
            date(year='2022')

        reference(anchor='MRO_CMW_EXPRESS' target='https://gitlab.cern.ch/mro/common/www/cmw-express')
          front
            title CMW plugin for Express.js
            author
              organization CERN
            date(year='2022')

        reference(anchor='MRO_SSVG' target='https://mro-dev.web.cern.ch/docs/std/ssvg-specification.html')
          front
            title Stateful Scalar Vector Graphics (SSVG)
            author
              organization CERN
            date(year='2022')

    //- section
    //-   name Change Log
    //-   t A list of changes

    //- section
    //-   name Open Issues
    //-   t A list of open issues regarding this document
